Package com.saxonica.ee.stream.adjunct

## Class FilterExpressionAdjunct

- java.lang.Object
- - com.saxonica.ee.stream.adjunct.StreamingAdjunct
  - - com.saxonica.ee.stream.adjunct.TransmissionAdjunct
    - - com.saxonica.ee.stream.adjunct.FilteringAdjunct
      - - com.saxonica.ee.stream.adjunct.FilterExpressionAdjunct

- All Implemented Interfaces:
    `FeedMaker`

      public class FilterExpressionAdjunct
      extends FilteringAdjunct

  Generate streaming code for a filter expression (when not part of a Watch).

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FilterExpressionAdjunct()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PostureAndSweep` | `computeStreamability​(ContextItemStaticInfoEE contextInfo, java.util.List<java.lang.String> reasons)` | Compute the posture and sweep of this expression as defined in the W3C streamability specifications.
    `FeedMaker` | `getFeedMaker​(int arg)` | Get a FeedMaker, a factory class that creates a Feed to evaluate this expression in streaming mode.
    `FilteringFeed.Filter` | `makeFilter​(XPathContext context, ItemFeed out)` | Make a filter for the event stream
    `void` | `setExpression​(Expression expression)` | Set the expression being processed by this StreamingAdjunct
    `Pattern` | `toStreamingPattern​(Configuration config)` | Convert this expression to a streaming pattern (a pattern used internally to match nodes during push processing of an event stream)

    - ### Methods inherited from class com.saxonica.ee.stream.adjunct.FilteringAdjunct

      `makeItemFeed`

    - ### Methods inherited from class com.saxonica.ee.stream.adjunct.TransmissionAdjunct

      `getWatchMaker, makeTransmissionFlow`

    - ### Methods inherited from class com.saxonica.ee.stream.adjunct.StreamingAdjunct

      `findConsumingArg, getConfiguration, getDefaultFeedMaker, getExpression, makeStreamingAdjunct, setConfiguration`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FilterExpressionAdjunct

          public FilterExpressionAdjunct()

  - ### Method Detail

    - #### setExpression

          public void setExpression​(Expression expression)

      Set the expression being processed by this StreamingAdjunct
      Overrides:
        `setExpression` in class `StreamingAdjunct`
      Parameters:
        `expression` - the expression being processed

    - #### computeStreamability

          public PostureAndSweep computeStreamability​(ContextItemStaticInfoEE contextInfo,
                                                      java.util.List<java.lang.String> reasons)

      Description copied from class: `StreamingAdjunct`
      Compute the posture and sweep of this expression as defined in the W3C streamability specifications. This must be implemented in all subclasses that don't use the general streamability rules. The implementation should have the side-effect of computing the streamability of all subexpressions, recursively.
      Overrides:
        `computeStreamability` in class `StreamingAdjunct`
      Parameters:
        `contextInfo` - Information about the context item type and posture
        `reasons` - the caller may supply a list, in which case the implementation may add to this; the contents are human-readable messages explaining why the expression is not streamable.
      Returns:
        the posture and sweep of the expression

    - #### toStreamingPattern

          public Pattern toStreamingPattern​(Configuration config)

      Convert this expression to a streaming pattern (a pattern used internally to match nodes during push processing of an event stream)
      Overrides:
        `toStreamingPattern` in class `StreamingAdjunct`
      Parameters:
        `config` - the Saxon configuration
      Returns:
        the equivalent pattern if conversion succeeds; otherwise null

    - #### makeFilter

          public FilteringFeed.Filter makeFilter​(XPathContext context,
                                                 ItemFeed out)

      Make a filter for the event stream
      Specified by:
        `makeFilter` in class `FilteringAdjunct`
      Parameters:
        `context` - the XPath dyamic context
        `out` - the next filter in the pipeline
      Returns:
        a filter that can be added to the event stream

    - #### getFeedMaker

          public FeedMaker getFeedMaker​(int arg)
                                 throws XPathException

      Description copied from class: `StreamingAdjunct`
      Get a FeedMaker, a factory class that creates a Feed to evaluate this expression in streaming mode. In many cases the StreamingAdjunct is itself a FeedMaker, in which case it returns itself. But where an expression has several operands, it will typically create different feeds depending on which argument is the streamed input, and in such cases the individual StreamingAdjunct makes the decision which feed to use, by returning an appropriate FeedMaker.
      Overrides:
        `getFeedMaker` in class `StreamingAdjunct`
      Parameters:
        `arg` - identifies the argument with respect to which the expression is to be inverted: usually 0 to indicate the first argument is the value that is streamed. Argument numbering is the same as the sequence of arguments/operands returned by the method `Expression.operands()`
      Returns:
        a FeedMaker to evaluate the expression, or null if it is not streamable with respect to the specificed argument.
      Throws:
        `XPathException` - in the event of a failure